"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard")["default"];
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Internal = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _react = _interopRequireWildcard(require("react"));
var _merge = require("@codemirror/merge");
var _store = require("./store");
var _jsxRuntime = require("react/jsx-runtime");
var Internal = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  var className = props.className,
    children = props.children;
  var _useStore = (0, _store.useStore)(),
    modified = _useStore.modified,
    original = _useStore.original,
    view = _useStore.view,
    dispatch = _useStore.dispatch;
  var editor = (0, _react.useRef)(null);
  (0, _react.useEffect)(function () {
    if (!view && editor.current && original && modified) {
      var viewDefault = new _merge.MergeView({
        a: original,
        b: modified,
        parent: editor.current
      });
      dispatch && dispatch({
        view: viewDefault
      });
    }
  }, [editor.current, original, modified, view]);
  (0, _react.useEffect)(function () {
    return function () {
      view && view.destroy();
    };
  }, []);
  var defaultClassNames = 'cm-merge-theme';
  return /*#__PURE__*/(0, _jsxRuntime.jsx)("div", (0, _objectSpread2["default"])((0, _objectSpread2["default"])({
    ref: editor,
    className: "".concat(defaultClassNames).concat(className ? " ".concat(className) : '')
  }, props), {}, {
    children: children
  }));
});
exports.Internal = Internal;