"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Original = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _react = require("react");
var _state = require("@codemirror/state");
var _store = require("./store");
var _reactCodemirror = require("@uiw/react-codemirror");
var Original = function Original(props) {
  var _props$extensions = props.extensions,
    extensions = _props$extensions === void 0 ? [] : _props$extensions;
  var _useStore = (0, _store.useStore)(),
    original = _useStore.original,
    view = _useStore.view,
    dispatch = _useStore.dispatch;
  var defaultExtensions = (0, _reactCodemirror.getDefaultExtensions)();
  (0, _react.useEffect)(function () {
    var data = {
      extensions: [].concat((0, _toConsumableArray2["default"])(defaultExtensions), (0, _toConsumableArray2["default"])(extensions))
    };
    if ((original === null || original === void 0 ? void 0 : original.doc) !== props.value && view) {
      data.doc = props.value;
      dispatch({
        original: (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, original), data)
      });
      var originalDoc = view === null || view === void 0 ? void 0 : view.a.state.doc.toString();
      if (originalDoc !== props.value) {
        view === null || view === void 0 ? void 0 : view.a.dispatch({
          changes: {
            from: 0,
            to: (originalDoc || '').length,
            insert: props.value || ''
          }
        });
      }
    }
    if ((original === null || original === void 0 ? void 0 : original.selection) !== props.selection) {
      data.selection = props.selection;
      dispatch({
        original: (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, original), data)
      });
    }
  }, [props.value, props.selection, view]);
  (0, _react.useEffect)(function () {
    if (view) {
      view.a.dispatch({
        effects: _state.StateEffect.appendConfig.of([].concat((0, _toConsumableArray2["default"])(defaultExtensions), (0, _toConsumableArray2["default"])(extensions)))
      });
    }
  }, [extensions, view]);
  return null;
};
exports.Original = Original;