import _extends from "@babel/runtime/helpers/extends";
import React, { useEffect, useRef } from 'react';
import { MergeView } from '@codemirror/merge';
import { useStore } from './store';
import { jsx as _jsx } from "react/jsx-runtime";
export var Internal = /*#__PURE__*/React.forwardRef((props, ref) => {
  var {
    className,
    children
  } = props;
  var {
    modified,
    original,
    view,
    dispatch
  } = useStore();
  var editor = useRef(null);
  useEffect(() => {
    if (!view && editor.current && original && modified) {
      var viewDefault = new MergeView({
        a: original,
        b: modified,
        parent: editor.current
      });
      dispatch && dispatch({
        view: viewDefault
      });
    }
  }, [editor.current, original, modified, view]);
  useEffect(() => {
    return () => {
      view && view.destroy();
    };
  }, []);
  var defaultClassNames = 'cm-merge-theme';
  return /*#__PURE__*/_jsx("div", _extends({
    ref: editor,
    className: "" + defaultClassNames + (className ? " " + className : '')
  }, props, {
    children: children
  }));
});