import _extends from "@babel/runtime/helpers/extends";
import { useEffect } from 'react';
import { StateEffect } from '@codemirror/state';
import { useStore } from './store';
import { getDefaultExtensions } from '@uiw/react-codemirror';
export var Original = props => {
  var {
    extensions = []
  } = props;
  var {
    original,
    view,
    dispatch
  } = useStore();
  var defaultExtensions = getDefaultExtensions();
  useEffect(() => {
    var data = {
      extensions: [...defaultExtensions, ...extensions]
    };
    if ((original == null ? void 0 : original.doc) !== props.value && view) {
      data.doc = props.value;
      dispatch({
        original: _extends({}, original, data)
      });
      var originalDoc = view == null ? void 0 : view.a.state.doc.toString();
      if (originalDoc !== props.value) {
        view == null ? void 0 : view.a.dispatch({
          changes: {
            from: 0,
            to: (originalDoc || '').length,
            insert: props.value || ''
          }
        });
      }
    }
    if ((original == null ? void 0 : original.selection) !== props.selection) {
      data.selection = props.selection;
      dispatch({
        original: _extends({}, original, data)
      });
    }
  }, [props.value, props.selection, view]);
  useEffect(() => {
    if (view) {
      view.a.dispatch({
        effects: StateEffect.appendConfig.of([...defaultExtensions, ...extensions])
      });
    }
  }, [extensions, view]);
  return null;
};